Bug 628213 - tac has a double-free bug (input line longer than 16KiB)
tac has a double-free bug (input line longer than 16KiB)
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: coreutils (Show other bugs)
13
All Linux
low Severity medium
: ---
: ---
Assigned To: Ondrej Vasik
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2010-08-28 12:42 EDT by Jim Meyering
Modified: 2013-03-13 16:41 EDT (History)
4 users (show)

See Also:
Fixed In Version: coreutils-8.4-9.fc13
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-10-19 03:13:11 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Jim Meyering 2010-08-28 12:42:26 EDT
Description of problem:
tac aborts due to a double free -- but only when an input line is longer than 16KiB

Steps to Reproduce:
1.valgrind tac <(printf %0$((2**14 + 1))d 0) > /dev/null
2.
3.
  
Actual results:
     Invalid free() / delete / delete[]
        at 0x4A04D72: free (vg_replace_malloc.c:325)
        by 0x402294: main (tac.c:669)
      Address 0x4c30040 is 0 bytes inside a block of size 16,388 free'd
        at 0x4A05255: realloc (vg_replace_malloc.c:476)
        by 0x4117B8: xrealloc (xmalloc.c:57)
        by 0x401A68: tac_seekable (tac.c:319)
        by 0x402379: main (tac.c:515)


Without valgrind, I get a backtrace, then this:

   zsh: abort (core dumped)  tac <(printf %0$((2**14 + 1))d 0) > /dev/null


Expected results:
  no double free/abort

Additional info:
  patch posted at http://bugs.debian.org/594666#10
Comment 1 Ondrej Vasik 2010-08-28 18:11:57 EDT
Thanks for heads-up, Jim.
Comment 2 Ondrej Vasik 2010-08-31 08:01:30 EDT
Built in rawhide as coreutils-8.5-5.fc15.
Comment 3 Fedora Update System 2010-10-01 07:53:17 EDT
coreutils-8.4-9.fc13 has been submitted as an update for Fedora 13.
https://admin.fedoraproject.org/updates/coreutils-8.4-9.fc13
Comment 4 Fedora Update System 2010-10-05 05:37:30 EDT
coreutils-8.4-9.fc13 has been pushed to the Fedora 13 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update coreutils'.  You can provide feedback for this update here: https://admin.fedoraproject.org/updates/coreutils-8.4-9.fc13
Comment 5 Fedora Update System 2010-10-19 03:13:01 EDT
coreutils-8.4-9.fc13 has been pushed to the Fedora 13 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.